/*
	Example embedding a tcl interpreter 
	for GUI enabling a Cobol program.

	Recife, Brazil, 2001 -- Rildo Pragana
*/

#include <tcl.h>
#include <tk.h>
#include <stdio.h>
#include <stdlib.h>

/**** general use tcl procs for processing arguments ****/
char cobtools[] = "proc split_fields {} {\n"
	"global data_block cobol_fields result_format\n"
	"set ix 0\nset result_format \"\"\n"
	"foreach {varname size} $cobol_fields {\nglobal $varname\n"
	"set $varname [string trimright [string range $data_block $ix [expr $ix+$size-1]]]\n"
	"incr ix $size\nappend result_format \"%-$size.${size}s\"\n}\n}\n"
	"proc do_exit {} {\nglobal result_format result ready cobol_fields\n"
	"foreach child [winfo children .] {\ndestroy $child\n"
	"}\nset vars {}\nforeach {varname size} $cobol_fields {\n"
	"upvar $varname v\nlappend vars $v\n}\n"
	"set result [eval format $result_format $vars]\nset ready 1\n}";

char *execgui = {
"namespace eval base64 {\n"
"    variable i 0\n"
"    variable char\n"
"    variable base64\n"
"    variable base64_en\n"
"    foreach char {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z \\\n"
"	      a b c d e f g h i j k l m n o p q r s t u v w x y z \\\n"
"	      0 1 2 3 4 5 6 7 8 9 + /} {\n"
"	set base64($char) $i\n"
"	set base64_en($i) $char\n"
"	incr i\n"
"    }\n"
"    namespace export *\n"
"}\n"
"proc base64::encode {args} {\n"
"    variable base64_en\n"
"    \n"
"    set wrapchar \"\\n\"\n"
"    set maxlen 60\n"
"    if { [llength $args] == 0 } {\n"
"	error \"wrong # args: should be \\\"[lindex [info level 0] 0]\\\n"
"		?-maxlen maxlen? ?-wrapchar wrapchar? string\\\"\"\n"
"    }\n"
"    set optionStrings [list \"-maxlen\" \"-wrapchar\"]\n"
"    for {set i 0} {$i < [llength $args] - 1} {incr i} {\n"
"	set arg [lindex $args $i]\n"
"	set index [lsearch -glob $optionStrings \"${arg}*\"]\n"
"	if { $index == -1 } {\n"
"	    error \"unknown option \\\"$arg\\\": must be -maxlen or -wrapchar\"\n"
"	}\n"
"	incr i\n"
"	if { $i >= [llength $args] - 1 } {\n"
"	    error \"value for \\\"$arg\\\" missing\"\n"
"	}\n"
"	set val [lindex $args $i]\n"
"	set [string range [lindex $optionStrings $index] 1 end] $val\n"
"    }\n"
"    \n"
"    if { ![string is integer -strict $maxlen] } {\n"
"	error \"expected integer but got \\\"$maxlen\\\"\"\n"
"    }\n"
"    set string [lindex $args end]\n"
"    set result {}\n"
"    set state 0\n"
"    set length 0\n"
"    foreach {c} [split $string {}] {\n"
"	if {$maxlen && $length >= $maxlen} {\n"
"	    append result $wrapchar\n"
"	    set length 0\n"
"	}\n"
"	scan $c %c x\n"
"	switch [incr state] {\n"
"	    1 {	append result $base64_en([expr {($x >>2) & 0x3F}]) }\n"
"	    2 { append result \\\n"
"		$base64_en([expr {(($old << 4) & 0x30) | (($x >> 4) & 0xF)}]) }\n"
"	    3 { append result \\\n"
"		$base64_en([expr {(($old << 2) & 0x3C) | (($x >> 6) & 0x3)}])\n"
"		append result $base64_en([expr {($x & 0x3F)}])\n"
"		incr length\n"
"		set state 0}\n"
"	}\n"
"	set old $x\n"
"	incr length\n"
"    }\n"
"    set x 0\n"
"    switch $state {\n"
"	0 { # OK }\n"
"	1 { append result $base64_en([expr {(($old << 4) & 0x30)}])== }\n"
"	2 { append result $base64_en([expr {(($old << 2) & 0x3C)}])=  }\n"
"    }\n"
"    return $result\n"
"}\n"
"proc base64::decode {string} {\n"
"    variable base64\n"
"    set output {}\n"
"    set group 0\n"
"    set j 18\n"
"    foreach char [split $string {}] {\n"
"	if {[string compare $char \"=\"]} {\n"
"	    if { ![info exists base64($char)] } {\n"
"		continue\n"
"	    }\n"
"	    set bits $base64($char)\n"
"	    set group [expr {$group | ($bits << $j)}]\n"
"	    if {[incr j -6] < 0} {\n"
"		scan [format %06x $group] %2x%2x%2x a b c\n"
"		append output [format %c%c%c $a $b $c]\n"
"		set group 0\n"
"		set j 18\n"
"	    }\n"
"	} else {\n"
"	    scan [format %06x $group] %2x%2x%2x a b c\n"
"	    if {$j == 6} {\n"
"		append output [format %c $a]\n"
"	    } elseif {$j == 0} {\n"
"		append output [format %c%c $a $b]\n"
"	    }\n"
"	    break\n"
"	}\n"
"    }\n"
"    return $output\n"
"}\n"
"namespace import base64::*\n"
"proc compare {s1 s2} {\n"
"    if {[string equal $s1 $s2]} {\n"
"	return equal\n"
"    }\n"
"    if {[string length $s1] != [string length $s2]} {\n"
"	return \"s1 length [string length $s1] != s2 length [string length $s2]\"\n"
"    }\n"
"    set i 0\n"
"    foreach c1 [split $s1 {}] c2 [split $s2 {}] {\n"
"	if {[string compare $c1 $c2] != 0} {\n"
"	    scan $c1 %c c1scanval\n"
"	    scan $c2 %c c2scanval\n"
"	    binary scan $c1 a c1binval\n"
"	    binary scan $c2 a c2binval\n"
"	    return \"char($i) c1 $c1 $c1scanval $c1binval c2 $c2 $c2scanval $c2binval\"\n"
"	}\n"
"	incr i\n"
"    }\n"
"}\n"
"proc exec_encoded {} {\n"
"	global encoded_source\n"
"	catch {file delete tmp.tcl.gz tmp.tcl}\n"
"	set f [open tmp.tcl.gz w]\n"
"	fconfigure $f -encoding binary -translation binary\n"
"	puts -nonewline $f [decode [string range $encoded_source 1 end]]\n"
"	close $f\n"
"	exec gunzip tmp.tcl.gz\n"
"	uplevel source tmp.tcl\n"
"	catch {file delete tmp.tcl}\n"
"}\n"
"flush stdout\n"
};

Tcl_Interp *interp;
int error_code;
Tk_Window mainwin;

void tcgui_do_exit() {
	char *einf;
	einf = Tcl_GetVar(interp,"errorInfo",TCL_GLOBAL_ONLY);
	fprintf(stderr,"*** TCGUI ERROR from Tcl interpreter:\n%s\n",einf);
	exit(1);
}

int initTcl () {
	int argc=0;
	char *argv[]= { "tinycobol", ""};

	interp = Tcl_CreateInterp();
	mainwin = Tk_MainWindow(interp);
	Tcl_AppInit(interp);
}

int endTcl () {
	Tcl_DeleteInterp(interp);
}

int testgui02(char *data, int *size, char *scriptn) {
	char *r;
	char *cobbuf;
	char *s;
	cobbuf = malloc(*size+1);
	memmove(cobbuf,data,*size);
	cobbuf[*size]=0;
	s=scriptn;
	while (*s != ' ') s++;
	*s=0;
//	printf("C received: %s\n",cobbuf);
	Tcl_SetVar(interp,"data_block",cobbuf,TCL_GLOBAL_ONLY);
	error_code = Tcl_Eval(interp,cobtools);
	if (error_code != TCL_OK)
		tcgui_do_exit();
	Tcl_SetVar(interp,"encoded_source",scriptn,TCL_GLOBAL_ONLY);
	//error_code = Tcl_EvalFile(interp, "execgui.tcl");
	error_code = Tcl_Eval(interp,execgui);
	if (error_code != TCL_OK)
		tcgui_do_exit();
	error_code = Tcl_Eval(interp,"exec_encoded");
	if (error_code != TCL_OK)
		tcgui_do_exit();
	r=Tcl_GetVar(interp, "result", TCL_GLOBAL_ONLY);
	if (r!=NULL) {
		memmove(data,r,strlen(r));
	}
	free(cobbuf);
}

int
Tcl_AppInit(Tcl_Interp *interp) {
    if (Tcl_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
    if (Tk_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
    Tcl_StaticPackage(interp, "Tk", Tk_Init, Tk_SafeInit);
    Tcl_SetVar(interp, "tcl_rcFileName", "~/.wishrc", TCL_GLOBAL_ONLY);
    return TCL_OK;
}

